#
# A very crude test runner script. Could be improved in many ways, e.g. no 
# automatic checking of output. But it is sufficient for the current simple script
#

$SCRIPT_NAME = ".\Collect-Content.ps1"

# -- Wrong parameters
echo "--Test case: folder does not exist"
# test should throw an error, thus call it inside a try, otherwise it terminates
# the whole test script
try {Invoke-Command -ScriptBlock {.\Collect-Content.ps1 -Folder c:\notexists} } 
catch {Write-Host -ForegroundColor Red "EXCEPTION: $($_.Exception.GetType()) `n $($_.Exception.Message)"}

# -- Tests without -Extensions
echo "`n--Test case: empty folder"
& $SCRIPT_NAME -Folder .\tests\test1

echo "`n--Test case: folder with one subfolder"
& $SCRIPT_NAME -Folder .\tests\test2

echo "`n--Test case: folder with several subfolders (3)"
& $SCRIPT_NAME -Folder .\tests\test3

echo "`n--Test case: folder with nested subfolders (7)"
& $SCRIPT_NAME -Folder .\tests\test4

# -- Tests with -Extensions
echo "`n--Test case: empty folder, no files"
& $SCRIPT_NAME -Folder .\tests\test1 -Extensions

echo "`n--Test case: only one file, with extension (.txt)"
& $SCRIPT_NAME -Folder .\tests\test2 -Extensions

echo "`n--Test case: several files, one most frequent extension (.txt)"
& $SCRIPT_NAME -Folder .\tests\test3 -Extensions

echo "`n--Test case: several files, two most frequent extensions (.txt, .cmd)"
& $SCRIPT_NAME -Folder .\tests\test4 -Extensions

echo "`n--Test case: files without extension"
& $SCRIPT_NAME -Folder .\tests\test5 -Extensions