
param (
	[Parameter(Mandatory=$true)][string] $Folder,
	[switch] $Extensions
)

if (! (Test-Path $Folder)){
	throw "$Folder does not exist!"
}

# count subfolders
$subfolders = (Get-ChildItem -Path $Folder -Directory -Recurse).Count

Write-Output "Subfolders in $Folder : $subfolders"

# count extensions
if ($Extensions){
	$maxExtension = Get-ChildItem -Path $Folder -Recurse -File |
	 Group-Object -Property extension | 
	 Sort-Object -Property Count -Descending | 
	 Select-Object -First 1 

	Write-Output "Most frequent extension: $($maxExtension.Name) ($($maxExtension.Count))"
}